
dropped = 0
spawnturn = 0
destroyed = 0

function onDeployStart()
	createStartingTroops(False)
	SetWinnable(false)
end

function createStartingTroops(forPlinthInspector)
	local Rank = GetPlayerCastleLevel()
		if Rank <= 3 then
			SpellLevel = 1
		elseif Rank == 4 then
			SpellLevel = 2
		elseif Rank == 5 then
			SpellLevel = 3
		elseif Rank == 6 then
			SpellLevel = 4
		elseif Rank == 7 then
			SpellLevel = 5
		elseif Rank == 8 then
			SpellLevel = 6
		elseif Rank == 9 then
			SpellLevel = 7
		elseif Rank == 10 then
			SpellLevel = 8
		elseif Rank == 11 then
			SpellLevel = 9
		elseif Rank == 12 then
			SpellLevel = 10
		elseif Rank > 12 then
			SpellLevel = 11
		end

	if forPlinthInspector then
			SpawnUnits("spawn1")
			SpawnUnits("spawn2")
			SpawnUnits("spawn1")
	end
end

-- no units alive at start of game so winnable set to false

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	SetDisplayTimer(0,0)
--	SetCinematicTimeout(-1)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter)
	DropSpell("Freeze19", 1, "place4")
	DropSpell("Lightning19", 1, "place2")
	ForceGiveMoveOrder("trigger1")

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_OUTPOST8_1")
	end
end

-- starts the combat, spawns first units on right side and start first timer for more spawns
function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		SpawnUnits("spawn1")
		ShowDialog("Portraits/Guard_talkinghead","TXT_OUTPOST8_2")	
		AddTimer(4.0,SetTutorial,"")
		AddTimer(10.0,SpawnLoop)
		DisableTrigger("trigger1")
	end
end


-- spawns left side units and starts timer to alternate between spawn sides on map, sets spawnturn to odd and even
function SpawnLoop()
	if spawnturn == 0 then
		RespawnUnits("spawn2")
		spawnturn = 1
		AddTimer(10.0,SpawnLoop)
	elseif spawnturn == 1 then
		RespawnUnits("spawn1")
		spawnturn = 0
		AddTimer(10.0,SpawnLoop)
	end
end

-- each time a spoil is picked up a new one will drop in the next place, alternates from place 1-4 and returns to 1
function onSpoilSpawned()
	if dropped == 0 then
		DropSpell("PoisonCloud", SpellLevel, "place1")
		dropped = dropped + 1
		elseif dropped == 1 then
			DropSpell("Fireball", SpellLevel, "place2")
			dropped = dropped + 1
		elseif dropped == 2 then
			DropSpell("Freeze", SpellLevel, "place3")
			dropped = dropped + 1
		elseif dropped == 3 then
			DropSpell("Lightning", SpellLevel, "place4")
			dropped = 0
	end
end

-- Using a spell will fire off a trigger to this function
function onSpellCast(spellName, level)
--	if spellName == "*" then
--		AddTimer(0.0,SetTutorial,"Spellcast!")
		AddTimer(2.0,onSpoilSpawned)
--	end
end


-- counts the number of dead units, sets the win condition back to true when 14 enemies have been killed
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed +1
	end
	if destroyed == 12 then
		SetWinnable(true)
	end
	if destroyed == 14 then
		Win()
	end
end










