
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0
playonce = 0
notindeployphase = false

-- no units alive at start of game so winnable set to false
function onDeployStart()
	SetWinnable(false)
	AddTargetCircleWithArrow("trigger1")

end


-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	notindeployphase = true
	CreateRandomisedListOfThings("spawn1","spawn2","spawn3","spawn4")
	SetDisplayTimer(0,0)	-- no timer on level
	SetVictoryBarEnabled(false)
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_SP3_1B")
		DropSpell("Lightning", 2, "place2")
	end
	if cameraName == "BATTLE_START" then
--		ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_SP3_2")
		SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter)
		DropSpell("Fireball", 2, "place4")


	end
end



--[[function RoK_MessageBoxFinished()
	if phase == 0 then
		SetTutorial("Hold the line!")
		phase = 1
	end
end]]


-- starts the combat, spawns first units on right side and start first timer for more spawns
function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_SP3_3")
		AddTimer(7.0, kickoff)
		DisableTrigger("trigger1")
		ClearTargetCircles()
		ShowUIGuideArrow("StandGuardBtn")
	end
end



function kickoff()
		notindeployphase = false
		SetDisplayTimer(45, 0)
		AddTimer(45.0, Lose)
		SetVictoryBarEnabled(false)
		SetupVictoryBar()
		ShowDialog("Portraits/Guard_talkinghead","TXT_SP3_4")
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())	
		RespawnUnits(GetRandomisedRandomThing())
		HideUIGuideArrow("StandGuardBtn")
end

-- each time a spoil is picked up a new one will drop in the next place, alternates from place 1-4 and returns to 1
function onSpoilSpawned()
	local i = math.random(1,8)
	if i == 1 then
		--ShowDialog("Portraits/Guard_talkinghead","TXT_SP3_5")
	elseif i == 2 then
		
	elseif 1 == 3 then
		--ShowDialog("Portraits/Guard_talkinghead","TXT_SP3_6")
	elseif i == 4 then
		
	elseif i == 5 then
		--ShowDialog("Portraits/Guard_talkinghead","TXT_SP3_7")
	elseif i == 6 then
		
	elseif i == 7 then
		--ShowDialog("Portraits/Guard_talkinghead","TXT_SP3_8")
	elseif i == 8 then
		
	end
	
	-- Drop spells for n turns and then give no more
	
	if dropped == 0 then
		DropSpell("PoisonCloud", 2, "place1")
		--ShowGuideArrowForNextSpellDrop()
		dropped = dropped + 1
	
	elseif dropped == 1 then
		DropSpell("Fireball", 2, "place3")
		dropped = dropped + 1
	elseif dropped == 2 then
		DropSpell("Fireball", 2, "place2")
		dropped = dropped + 1
	elseif dropped == 3 then
		DropSpell("Lightning", 2, "place4")
		dropped = dropped + 1
	elseif dropped == 4 then
		DropSpell("Fireball", 2, "place1")
		dropped = dropped + 1
	elseif dropped == 5 then
		DropSpell("PoisonCloud", 2, "place3")
		dropped = dropped + 1
	elseif dropped == 6 then
		DropSpell("Fireball", 2, "place2")
		dropped = dropped + 1
	end
end

-- Collecting a spoil shpould fire off a trigger to this function
function onSpellCollected(spellName, level)
--	SetTutorial("Drag a spell from the bar and position it over an enemy unit.")
--	ClearAllGuideArrows()
end

-- Using a spell will fire off a trigger to this function
function onSpellCast(spellName, level)
  if spellName == "Lightning" or spellName == "PoisonCloud" then
    Lose()
  end
	-- when they use a spell, drop another one a little later than the last
	AddTimer((dropped * 2) + 1,onSpoilSpawned)
end


-- counts the number of dead units, sets the win condition back to true when 10 enemies have been killed
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed +1
	end
	if destroyed == 3 then
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
	end
	if destroyed == 6 then
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
--		ShowDialog("Portraits/Guard_talkinghead","Not many more of them left")
	end
	if destroyed == 9 then
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
		RespawnUnits(GetRandomisedRandomThing())
		ShowDialog("Portraits/Guard_talkinghead","This is the last of their army")
		SetWinnable(true)
	end
	if destroyed == 12 then
--		Win()
	end
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/12)
	AddVictoryBarMarker(6/12)
	AddVictoryBarMarker(9/12)
	AddVictoryBarMarker(1.0)
end
