
-- Save the Titan
phase = 0
TrystanPhase = 0
TrystanHealth = 0
TrystanEnemyToPlayer = false
ArchersKilled = false

function onDeployStart()
--	initial set up
-- Side 0 is player, Side 1 is enemy, Side 2
--  Setting the triggers so they work	
	SetTriggerCallbacks("EnemyFirstWave", EnemyFirstWave_onTriggerEnter, EnemyFirstWave_Confirmed_onTriggerleave)
	SetTriggerCallbacks("EnemyReinforcements", EnemyReinforcements_onTriggerEnter, EnemyReinforcements_onTriggerLeave)	
	SetTriggerCallbacks("TitanReleaseToPlayer", TitanReleaseToPlayer_onTriggerEnter, TitanReleaseToPlayer_onTriggerLeave)	
	SetVictoryBarEnabled( false )
	SetWinnable(false) -- Stopping the battle from finishing too soon without achieving their objective.
	ShowDialog("Portraits/Guard_talkinghead", "There are rumours of a Titan in the Forest. \nDestroy the dark spawn and discover the truth.")
end

function onCameraAnimationFinish(cameraName)
--	SetTutorial("camera is "..cameraName) -- lets you know what camera it is
	if cameraName == "BATTLE_START" then
		if phase == 0 then
--			ShowDialog("Portraits/Guard_talkinghead", "There are rumours of a Titan  \nDestroy the dark spawn! Discover the truth.")
			ShowDialog("Portraits/Guard_talkinghead","Sweep the enemy aside! Find the source of the rumours!")
			phase = 1
		end	
--	elseif cameraName == "BATTLE_INTRO" and phase == 1 then
--		ShowDialog("Portraits/Guard_talkinghead","Sweep the enemy aside!")
--		phase = 2
	end
end	
	

function onLevelStart()
	TrystanHealthCheck() 	-- Callback Ensuring Trystan is alive when under player control
	HealthCheck()				-- Callback Ensuring Trystan is alive when under Script control 
	SetDisplayTimer(0,0) 		-- Stops the timer from unnecessarily freaking the user or stopping completion
	SetAlliedPlayers(1, 3) 	-- Ensuring that the enemy don't fight
	SetAlliedPlayers(1, 2)	-- Ensuring the player and hero don't fight. Side 0 is player, Side 1 is enemy, Side 2 neutral titan
	local units = GetUnits("", "Hero", 2) 
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, true) -- Stops the hero wandering off and being hard to find
	end	
	local units = GetUnits("", "*", 3) -- Allies to enemy defending faction -- ADDED IN TURNING DAMAGE OFF FOR END ARMIES FIGHTING BATTLE HERE --
	for i,unit in pairs(units) do
		DisableAttackDamage(unit) 
	end	
end

function onUnitDestroyed(unit) -- Making sure we get callbacks for appropriate unit deaths
	Trystan_onUnitDestroyed(unit) 
	Archer_onUnitDestroyed(unit)
end

function EnemyFirstWave_onTriggerLeave(unit)
	if unit.attacker and phase == 1 then
		ShowDialog("Portraits/Guard_talkinghead","Keep moving, \nWe must discover the source of the rumours")	-- making sure the player remembers what they are doing and adding urgency to the game play	
		DisableTrigger("EnemyFirstWave")
		Phase = 3
	end	
end

function onAttackerDestroyed() -- Player messed up and lost all their units before the titan was rescued
	if phase == 3 then
		Lose()
	end
end

-- the player has destroyed the first set of enemy archers
function Archer_onUnitDestroyed(unit)
	if unit.id == "CampArcher" and ArchersKilled == false then
		SpawnUnits("EnemyReinforcements1")		
		ShowDialog("Portraits/Guard_talkinghead","Destroy the enemy. We must not fail")
		ArchersKilled = true
		local units = GetUnits("", "*", 3) -- Switching the enemy reinforcements to the enemy defender side
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
		end			
		local units = GetUnits("EnemyReinforcements1", "*", 3) -- Reinforcing Enemy Allies to enemy defending faction TURNING DAMAGE OFF HERE --
			for i,unit in pairs(units) do
			DisableAttackDamage(unit) 
		end	
	end
end


-- THE PLAYER GOT TO TRYSTAN AND Enemy NOW CONTROLS HIM
function TitanEnemyToPlayer_onTriggerEnter(unit)
	if unit.attacker and TrystanEnemyToPlayer == false then

--		SetPanningCamera(25.1, -48.4, 25, 0.35, -0.17) -- focusX, focusY, zoom, heading, pitch	
		ShowDialog("Portraits/Hero_Large","Ha you have fallen in to my trap!.")
		local unitsA = GetUnits("", "Hero", 2) 
		for i,unit in pairs(unitsA) do
			SwitchSide(unit, 1)
		end
--		local unitsB = GetUnits("", "Hero", 0) -- Telling the hero to stop running off without player orders for a few moments
--		for i,unit in pairs(unitsB) do
--			SetUnitStandGround(unit, true)
--		end	
		local unitsC = GetUnits("", "*", 3) -- Switching the enemy reinforcements to the enemy defender side
		for i,unit in pairs(unitsC) do
			SwitchSide(unit, 1)
		end			
		TrystanEnemyToPlayer = true	
		SetWinnable(true)
	end	
end



--TELLING THE PLAYER TO HURRY UP AND RESCUE TRYSTAN
function HealthCheck()
  AddTimer(1.0, HealthCheck)
	local units = GetUnits("", "Hero", 2) 
	for i,unit in pairs(units) do
		if unit.health <= 0.8 and TrystanPhase == 0 then
			ShowDialog("Portraits/Guard_talkinghead","Hurry! The enemy seek to destroy the Titan")			
			TrystanPhase = 1
			phase = 4
		elseif unit.health <= 0.6 and TrystanPhase == 1 then
			ShowDialog("Portraits/Hero_Large","So... many...enemies. \nSome... help... would be appreciated")			
			TrystanPhase = 2	
		end
	end	
end

-- NOW THE PLAYER HAS TRYTAN HE MUSNT LET HIM DIE
function TrystanHealthCheck()
  AddTimer(1.0, TrystanHealthCheck)
	local units = GetUnits("", "Hero", 0) 
	for i,unit in pairs(units) do
		if unit.health <= 0.6 and TrystanHealth == 0 then
			ShowDialog("Portraits/Guard_talkinghead","Kill The enemy. They seek to destroy the Titan")			
			TrystanHealth = 1
			phase = 4
		elseif unit.health <= 0.3 and TrystanHealth == 1 then
			ShowDialog("Portraits/Hero_Large","So... many...enemies.")			
			TrystanHealth = 2	
		end
	end	
end

-- THE PLAYER LET TRYSTAN DIE
function Trystan_onUnitDestroyed(unit)
	if unit.id == "Hero" and phase == 4 then
		ShowDialog("Portraits/Guard_talkinghead","Too Late!")
		Lose()		
	end
end

-- THE PLAYER WON	FELT TOO SUDDEN AND UNSATISFYING
--function onDefenderDestroyed()
--	if 	TrystanGivenToPlayer == true and Phase == 3 then
--		Win()
--	end
--end


