

phase = 0
destroyed = 0
freyaspawned = 0
playonce = 0
finish = 0

-- intro text before deployment starts - set the scene for the world and the battle
function onDeployStart()
	ShowMessageBox("Many years ago...", "An Epic battle was fought, a battle that would change the landscape forever... \n\n\n\n Please press FIGHT to continue")
end

-- 
function onLevelStart()
	SetMinimalUI()
	ShowMessageBox("Intro", "One Hero held the key to bringing peace across the land. \n\n A peace that would unite the clans and put an end to Almarand the Fallen's brutal reign...")
	PlayCameraAnimation("TUTORIAL_CAM")
	SetWinnable(false)
	SetCinematicTimeout(-1)
	SetDisplayTimer(0,0)
	SetTriggerCallbacks("Endgame", Endgame_onTriggerEnter) 
	SetTriggerCallbacks("Trigger1", Trigger1_onTriggerEnter)
	SetTriggerCallbacks("StaffofPower", StaffofPower_onTriggerEnter)
	SetTriggerCallbacks("Camerabox", Camerabox_onTriggerEnter)
	SetAI1()
	SetAI2()
--	SetCamera(0,0,-99,30,50)
end



-- freeze army side 1 in place
function SetAI1()
	local units = GetUnits("*", "*", 2) 
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, true)
	end
end

-- freeze army side 2 in place
function SetAI2()
	local units = GetUnits("*", "*", 3) 
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, true)
	end
end

-- unfreeze army side 1
function SetAI3()
	local units = GetUnits("*", "*", 2) 
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, false)
	end
end


-- unfreeze army side2 
function SetAI4()
	local units = GetUnits("*", "*", 3) 
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, false)
	end
end


-- when dialogue box is finished deselect player unit and set phase to 1
function RoK_MessageBoxFinished()
	if phase == 0 then
		phase = 1
		onUnitDeselected()
	end
end


function onUnitSelected(unit)
	if phase == 1 then
		SetTutorial("Drag from your unit to the target to give a move order. ")
		ForceGiveMoveOrder("Trigger1")
	elseif phase == 2 then
		SetTutorial("Drag from a unit to the enemy to attack them.")
		ForceGiveAttack()
	elseif phase == 3 then
		ForceGiveMoveOrder("StaffofPower")
	elseif phase == 4 then
		ForceGiveMoveOrder("Endgame")
	end	
end

function onUnitDeselected()
	if phase < 2 then
		SetTutorial("Tap on the highlighted unit to select it.")
		local allies = GetUnits("*", "*", 0) -- get all attackers	
		ForceSelectAlly(allies[1])
	end
end

-- Enter first trigger to spawn an enemy unit
function Trigger1_onTriggerEnter(unit)
	if unit.attacker and phase == 1 then
	    AddTimer(0.0,SetTutorial,"Enemy forces have appeared ahead!","this popup at 0 second")
		AddTimer(4.0,SetTutorial,"Drag from a unit to the enemy to attack them.","this popup at 3 second")
		SpawnUnits("killsingle")
		phase = 2
		ForceGiveAttack()
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		SetTutorial("")
		destroyed = destroyed + 1
		if phase == 2 then
			AddTimer(0.0,SetTutorial,"More units are approaching!","this popup at 0 second")
			AddTimer(4.0,SetTutorial,"Command your unit to attack them!","this popup at 3 second")
			SpawnUnits("killmultiple")
			onUnitDeselected()
			ForceGiveAttack()
			phase = 3
		end
		if destroyed == 3 then
			AddTimer(0.0,SetTutorial,"Grab the Staff or Power before the skeletons do!","this popup at 3 second")
			SpawnUnits("spawn4")
			ForceGiveMoveOrder("StaffofPower")
		end
		if destroyed == 13 then
			AddTimer(0.0,SetTutorial,"Get to the battle and destroy Almarand!","this popup at 0 second")
			ForceGiveMoveOrder("Endgame")
		end
	end
end


function StaffofPower_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("Portraits/PaladdinHero", "FREE! Free at last...\nI sense a battle raging across this land...")
    ShowDialog("Portraits/PaladdinHero", "We must use the Staff of Power to defeat Almarand and put a stop to all this bloodshed")
		DisableTrigger("StaffofPower")
		SpawnUnits("Hero")
		DropSpell("Apocalypse", 1, "StaffofPower")
		phase = 4
		freyaspawned = 1
		ClearAllGuideArrows()
	end
end


function Camerabox_onTriggerEnter(unit)
	if unit.attacker then
		if freyaspawned == 0 and playonce == 0 then
			ShowDialog("Freya", "Free me from these bonds! Almarand will destroy you if you go alone!")
			ShowGuideArrowForTrigger("StaffofPower")
			RespawnUnits("spawn4")
			playonce = 1
		end
		if freyaspawned == 1 then
			RespawnUnits("spawn5")
			RespawnUnits("spawn6")
			ShowDialog("Tutorial", "You can rotate the camera to get a better view of the canyon \n\n Use two fingers and turn them clockwise or anti-clockwise to rotate your view")
			DisableTrigger("Camerabox")
			SetAI3()
			SetAI4()
			ShowGuideArrowForTrigger("Endgame")
		end
	end
end

function Endgame_onTriggerEnter(unit)
	if unit.attacker and phase == 4 then
		SetTutorial("Use the Spell!")
		SetTroopAndSpellSelectorEnabled(true)
		finish = 1
	end
end	

function onSpellCast(spellName, level)
	if spellName == "Apocalypse" and finish == 1 then	
		SetTutorial("")
		PlaySwfMovie("Media/UI/IntroCinematic.swf")
		WinSilently()
	end
end





































