SpellLevel = 0
Army = 0 --Equal in rank to player troops
Army1 = 0 --1 level lower in rank to player troops
Army2 = 0 --2 level lower in rank to player troops & enemy Titan goes here!
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	createStartingTroops(False)  -- This establishes the scaling and what shows on the plinth inspector
	local units = GetUnits("*", "UnakHeroVerD*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
	SetTriggerCallbacks("trap1", trap1_onTriggerEnter, trap1_onTriggerLeave)
end

function onLevelStart()
	SetWinnable(false)	
	SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "UnakHeroVerD*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
	GiveNamedUnitMoveOrder("titan", "retreat")  -- tells the unit to run away
	Standstill() -- tells the unit to stand ground
end

--where we define what happens when the player triggers these zones
function trap_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(30,portalleft)
		DisableTrigger("trap")
	end
end

function trap1_onTriggerEnter(unit)
	if unit.attacker then
		RespawnUnits("spawn",Army1)
		Standstill2()
		DisableTrigger("trap1")
	end
end

--where we define the entry of the portal enemies along with the vfx required
function portalleft()
    PlayVFX("ElderStone_EnergyPropStones", "glowleft")
	PlayVFX("PA_SpawnReinforcement", "enterleft")
	AddTimer(1,enterleft)
end
function portalright()
    PlayVFX("ElderStone_EnergyPropStones", "glowright")
	PlayVFX("PA_SpawnReinforcement", "enterright")
	AddTimer(1,enterright)
end
function enterleft()
    RespawnUnits("spawn1",Army1)
	StopVFX("ElderStone_EnergyPropStones", "glowleft")
	AddTimer(30,portalright)
end
function enterright()
    RespawnUnits("spawn2",Army1)
	StopVFX("ElderStone_EnergyPropStones", "glowright")
	AddTimer(30,portalleft)
end

--defining changes of states based on enemy death count in the battle
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if unit.spawnId == "titan" then
            Win()		
		end
	end
end

-- this is where we define what the titan should be doing at their retreat location.
function Standstill() -- tells the unit to stand ground
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, true)
	end
	SetCanGrowAwareness("titan",false)
end

function Standstill2() -- tells the unit to stand ground
	local units = GetUnits("*", "titan", 1)
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, true)
	end
	SetCanGrowAwareness("titan",false)
	AddTimer(5.0,awarenesson)	
end

function awarenesson()
	SetCanGrowAwareness("titan",true)
end

--Here is where the ranking of the grind will be made for enemy levels
function createStartingTroops(forPlinthInspector)
Rank = GetPlayerCastleLevel()					
		if Rank <= 12 then			
			Army = 12
			Army1 = 11
			Army2 = 10
			SpellLevel = 10
		elseif Rank == 13 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 14 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 15 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 16 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 17 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 18 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank == 19 then			
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
		elseif Rank >= 20 then
			Army = Rank
			Army1 = Rank -1
			Army2 = Rank -2
			SpellLevel = Rank -2
	end
	
	--Examples of how you would setup the default starting units below. All units that start on the battlefield should be listed here.
	SpawnUnits("start",Army)   
	SpawnUnits("start1",Army1)
	SpawnUnits("titan",Army2)
		
	if forPlinthInspector then  --These units appear on the plinth inspector and should only include enemy units 
	    SpawnUnits("start",Army)
	    SpawnUnits("start1",Army1)
	    SpawnUnits("titan",Army2)
		RespawnUnits("spawn",Army1)
		RespawnUnits("spawn1",Army1)
		RespawnUnits("spawn2",Army1)
	end
end