
-- Global variables, sets variables for the skeletons to appear.
spawnCounter = 0
spawnTurn = 0
SpellLevel = 0
Army = 0
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

--deploy phase, sets the initial 2 talking heads to set the scene
function onDeployStart()
 ShowDialog("Portraits/Guard_talkinghead", "TXT_SP16_1")
 ShowDialog("Portraits/dip_alm_talkinghead", "TXT_SP16_2")	
 
	local units = GetUnits("*", "Leader", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end	
	createStartingTroops(False)
	PlayVFX("ElderStone_EnergyProp", "stone")
	PlayVFX("ElderStone_EnergyPropStones", "stone1")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyPropStones", "stone3")
	PlayVFX("ElderStone_EnergyPropStones", "stone4")
	PlayVFX("ElderStone_EnergyPropStones", "stone5")
	PlayVFX("ElderStone_EnergyPropStones", "stone6")
	PlayVFX("ElderStone_EnergyPropStones", "stone7")
	PlayVFX("ElderStone_EnergyPropStones", "stone8")
	PlayVFX("ElderStone_EnergyPropStones", "stone9")
	PlayVFX("ElderStone_EnergyPropStones", "stone10")
	
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 6
	SpellLevel = 4
	Army = 4
	Army1 = 5
	Army2 = 6

	SpawnUnits("start",Army2)
	SpawnUnits("Leader",Army)

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Leader",Army)
		SpawnUnits("start",Army2)
		SpawnUnits("start2",Army)
		SpawnUnits("skeleton1",Army)
		SpawnUnits("skeleton1",Army)
	end
end
	
	

-- battle start
function onLevelStart()
	SetDisplayTimer(0,0)
	SetWinnable(false)
	AddTimer(8.0,SpawnLoop)
	AddTimer(15.0,reinforcements)	
	SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end	
	
end

function reinforcements()
	SpawnUnits("start2",Army)
	ShowDialog("Portraits/Guard_talkinghead", "TXT_SP16_8")	
end
	 
	 
-- spawns troops alternating between sides
function SpawnLoop()
 	spawnCounter = spawnCounter + 1
	if spawnTurn == 0 then
	ShowDialog("Portraits/dip_alm_talkinghead", "TXT_SP16_3")
		PlayVFX("PA_SpawnReinforcement", "impact2")	
		AddTimer(2.0, spawnme)
		spawnTurn = 1
	elseif spawnTurn == 1 then
		PlayVFX("PA_SpawnReinforcement", "impact1")
		AddTimer(2.0, spawnme2)
	--ShowDialog("Portraits/dip_alm_talkinghead", "TXT_SP16_4")	
		spawnTurn = 2
	elseif spawnTurn == 2 then
		PlayVFX("PA_SpawnReinforcement", "impact3")
		AddTimer(2.0, spawnme3)
		spawnTurn = 3
	elseif spawnTurn == 3 then
		PlayVFX("PA_SpawnReinforcement", "impact4")
		AddTimer(2.0, spawnme4)
		spawnTurn = 0
	end
	
	if spawnCounter <= 8 then
		AddTimer(8.0,SpawnLoop)
	end
end


function spawnme()
	RespawnUnits("skeleton1",Army)
end

function spawnme2()
	RespawnUnits("skeleton2",Army)
end

function spawnme3()
	RespawnUnits("skeleton3",Army1)
end

function spawnme4()
	RespawnUnits("skeleton4",Army1)
end



-- Trigger when SP16HERO dies, with delay before win condition triggers
function onUnitDestroyed(unit)
	if unit.spawnId == "Leader" then
	AddTimer(3,YouWon)	
	ShowDialog("Portraits/Guard_talkinghead", "TXT_SP16_5")	
  end
end

--End win function ends the battle once the unit has killed and time elapsed
function YouWon()
	Win()
end