function onDeployStart()
	
	SetWinnable(false)
	ShowDialog("Portraits/Soldier_talkinghead", "TXT_CAMPAIGN_10_10_1")
	ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN_10_10_2")
	
end

function onLevelStart()
	
	SetAlliedPlayers(0, 2)
	SetEnemyPlayers(1,2)
	
	units = GetUnits("*","Hero_Story_Commander*")
	CheckCommanderHealth(units[1],0)
	
	SecondWaveStandGround(true)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		ClearShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN_10_10_3")
		
	end
end

function CheckCommanderHealth(enemyCommanderUnit,messagesShown)
	
	--print(enemyCommanderUnit.health)
	
	if enemyCommanderUnit.health < 0.6 and messagesShown == 0 then
	
		ClearShowDialog("Portraits/Soldier_talkinghead", "TXT_CAMPAIGN_10_10_4")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 1
		
	elseif enemyCommanderUnit.health < 0.4 and messagesShown == 1 then
	
		ClearShowDialog("Portraits/Soldier_talkinghead", "TXT_CAMPAIGN_10_10_5")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 2
		
	elseif enemyCommanderUnit.health < 0.2 and messagesShown == 2 then
	
		ClearShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN_10_10_6")
		InvincibleForShortTime(enemyCommanderUnit)
		messagesShown = 3
	
	end
	
	if enemyCommanderUnit.health > 0 then
		AddTimer(1,CheckCommanderHealth,enemyCommanderUnit,messagesShown)
	end
end

function onUnitDestroyed(unit)
	
	if unit.id == "Hero_Story_Commander7" then
		AddTimer(1,ClearShowDialog,"Portraits/Guard_talkinghead", "TXT_CAMPAIGN_10_10_7")
		AddTimer(3,Lose)
	else
		remainingUnits = GetUnits("*","*",1)
		if #remainingUnits <= 0 then
			AddTimer(1,Win)
		elseif #remainingUnits <= 7 then
			SecondWaveStandGround(false)
		end
	end
end

function ClearShowDialog(talkingHead, message)
	HideDialog()
	ShowDialog(talkingHead, message)
end

function InvincibleForShortTime(unit)
	EnableInvincibility(unit)
	AddTimer(5,DisableInvincibility,unit)
end

function SecondWaveStandGround(standGround)
	
	units = GetUnits("secondWave_[START]")
	for i,unit in pairs(units) do
		SetUnitStandGround(unit, standGround)
	end
	
end