destroyed = 0
SpellLevel = 0
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
    SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(0.2, story)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

function story()
    ShowDialogEternal("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_1")
	AddTimer(7, startgame)
end

function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
    SetupVictoryBar()
    AddTimer(1,fireballwave1)
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_2")
end

--fireball wave calls
function fireballwave1()
	CastSpell("FireBall", 1, "fire5",0)
	CastSpell("FireBall", 1, "fire6",0)
	AddTimer(3,wave1)
end
function fireballwave2()
	CastSpell("FireBall", 1, "fire1",0)
	CastSpell("FireBall", 1, "fire2",0)
	AddTimer(3,wave2)
end
function fireballwave3()
	CastSpell("FireBall", 1, "fire3",0)
	CastSpell("FireBall", 1, "fire4",0)
	AddTimer(3,wave3)
end

--enemy wave calls
function wave1()
    GiveNamedUnitMoveOrder("wave1", "attack")
end
function wave2()
    GiveNamedUnitMoveOrder("wave2", "attackleft")
end
function wave3()
    GiveNamedUnitMoveOrder("wave3", "attackright")
end
function wave4()
	PlayVFX("PA_SpawnReinforcement", "portal1")
	PlayVFX("PA_SpawnReinforcement", "portal2")
	PlayVFX("PA_SpawnReinforcement", "portal3")
	AddTimer(1, spawnwave4)
end

function spawnwave4()
	SpawnUnits("wave4a")
	SpawnUnits("wave4b")
	SpawnUnits("wave4c")
	AddTimer(0.5, wave4order)
end

function wave4order()
    GiveNamedUnitMoveOrder("wave4a", "attack")
	GiveNamedUnitMoveOrder("wave4b", "attack")
	GiveNamedUnitMoveOrder("wave4c", "attack")
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			SetVictoryBarFill(0.1)
		end
		if destroyed == 2 then
			SetVictoryBarFill(0.15)
		end
		if destroyed == 3 then
		    AddTimer(4,fireballwave2)
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_3")
			SetVictoryBarFill(0.25)
		end
		if destroyed == 4 then
			SetVictoryBarFill(0.30)
		end
		if destroyed == 5 then
			SetVictoryBarFill(0.40)
		end
		if destroyed == 6 then
		    AddTimer(4,fireballwave3)
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_4")
			SetVictoryBarFill(0.5)
		end
		if destroyed == 7 then
			SetVictoryBarFill(0.55)
		end
		if destroyed == 8 then
		    AddTimer(2,wave4)
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_5")
			SetVictoryBarFill(0.65)
		end
		if destroyed == 9 then
			SetVictoryBarFill(0.75)
		end
		if destroyed == 10 then
			SetVictoryBarFill(0.8)
		end
		if destroyed == 11 then
			SetVictoryBarFill(0.9)
		end
		if destroyed == 12 then
		    AddTimer(6,winner)
			ShowDialogEternal("Portraits/Guard_talkinghead","TXT_CAMPAIGN_10_3_6")
			SetVictoryBarFill(1)
		end
	end
end

function winner()
    HideDialog()
    SetWinnable(true)
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(0.25)
	AddVictoryBarMarker(0.5)
	AddVictoryBarMarker(0.75)
	AddVictoryBarMarker(1.0)
end

function createStartingTroops(forPlinthInspector)
        SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("wave3")
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
        SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("wave3")
		SpawnUnits("wave4a")
		SpawnUnits("wave4b")
		SpawnUnits("wave4c")
	end
end










