SpellLevel = 0
Army = 0
Rank = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
    SetWinnable(false)	-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	AddTimer(0.2, story)  -- calls story function
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
end

--story dialog
function story()
    ShowDialogEternal("Portraits/Guard_talkinghead","TXT_CAMPAIGN10C_6_1")
	AddTimer(7, startgame)
end

--removes dialog and adds combat buttons onto screen
function startgame()
    HideDialog()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetVictoryBarFill(0)
end

--sets the triggers in the level
function onLevelStart()
	SetTriggerCallbacks("firetrap", firetrap_onTriggerEnter, firetrap_onTriggerLeave)
	SetTriggerCallbacks("firetrap1", firetrap1_onTriggerEnter, firetrap1_onTriggerLeave)
	SetTriggerCallbacks("firetrap2", firetrap2_onTriggerEnter, firetrap2_onTriggerLeave)
	SetTriggerCallbacks("firetrap3", firetrap3_onTriggerEnter, firetrap3_onTriggerLeave)
	SetTriggerCallbacks("trap", trap_onTriggerEnter, trap_onTriggerLeave)
	SetTriggerCallbacks("fire", fire_onTriggerEnter, fire_onTriggerLeave)
	SetTriggerCallbacks("fire1", fire1_onTriggerEnter, fire1_onTriggerLeave)
	SetTriggerCallbacks("gate", gate_onTriggerEnter, gate_onTriggerLeave)
end

--first trigger at opening of level
function firetrap_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("firetrap")
	end
end
--second trigger after first gated wall is passed through by the players units
function firetrap1_onTriggerEnter(unit)
	if unit.attacker then
        enemywave1()
		DisableTrigger("firetrap1")
		ClearTargetCircles()
	end
end
--third trigger after second gated wall is passed through by the players units
function firetrap2_onTriggerEnter(unit)
	if unit.attacker then
        enemywave2()
		DisableTrigger("firetrap2")
		ClearTargetCircles()
	end
end
--third trigger after third gated wall is passed through by the players units
function firetrap3_onTriggerEnter(unit)
	if unit.attacker then
        enemywave3()
		DisableTrigger("firetrap3")
		ClearTargetCircles()
	end
end

--trap trigger for when player walks into it and will get ambushed
function trap_onTriggerEnter(unit)
	if unit.attacker then
        SpawnUnits("startambush")
		DisableTrigger("trap")
	end
end

--Traps of fireballs that will spawn behind the players location are set here
function fire_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("fire")
		--AddTimer(3,explosion)
	end
end

--Where the explosion fireballs located behind player are called in.
function explosion()
	CastSpell("FireBall", 5, "explosion1",0)
end
function explosion1()
	CastSpell("FireBall", 5, "explosion4",0)
end
function explosion2()
	CastSpell("FireBall", 5, "explosion3",0)
end

--Portal spawning enemies created here
--1st spawning wave
function enemywave1()
	PlayVFX("PA_SpawnReinforcement", "entry")
	PlayVFX("PA_SpawnReinforcement", "entry2")
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN10C_6_2")
	AddTimer(1, spawnwave1)
end
function spawnwave1()
	SpawnUnits("start1")
end
--2nd spawning wave
function enemywave2()
	PlayVFX("PA_SpawnReinforcement", "entry4")
	PlayVFX("PA_SpawnReinforcement", "entry5")
	PlayVFX("PA_SpawnReinforcement", "entry6")
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN10C_6_3")
	AddTimer(1, spawnwave2)
end
function spawnwave2()
	SpawnUnits("start2")
end
--3rd spawning wave
function enemywave3()
	PlayVFX("PA_SpawnReinforcement", "entry9")
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN10C_6_4")
	AddTimer(1, spawnwave3)
end
function spawnwave3()
	SpawnUnits("start3")
	SpawnUnits("starttitan")
end

function gate_onTriggerEnter(unit)
	if unit.attacker then
       -- AddTimer(0.1,firegate)
		--DisableTrigger("gate")
	end
end
function firegate()
    CastSpell("FireBall", 1, "fireball4",0)
	CastSpell("FireBall", 1, "fireball5",0)
	CastSpell("FireBall", 1, "fireball6",0)
	AddTimer(5,circletarget1)
end

function circletarget()
    AddTargetCircleWithArrow("circle1")
end
function circletarget1()
    AddTargetCircleWithArrow("circle2")
end
function circletarget2()
    AddTargetCircleWithArrow("circle3")
end

--enemy units destroyed and the effects they will give out
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			SetVictoryBarFill(0.05)
		end
		if destroyed == 2 then
			SetVictoryBarFill(0.1)
		end
		if destroyed == 3 then
			SetVictoryBarFill(0.15)
		end
		--4 = initial first wave of enemies completed
		if destroyed == 4 then
			SetVictoryBarFill(0.2)
			CastSpell("FireBall", 1, "fireball1",0)
	        CastSpell("FireBall", 1, "fireball2",0)
			CastSpell("FireBall", 1, "fireball3",0)
			AddTimer(2,explosion)
			AddTimer(5,circletarget)
		end
		if destroyed == 5 then
			SetVictoryBarFill(0.3)
		end
		if destroyed == 6 then
			SetVictoryBarFill(0.35)
			AddTimer(0.1,firegate)
			AddTimer(2,explosion1)
		end
		if destroyed == 7 then
			SetVictoryBarFill(0.4)
		end
		if destroyed == 8 then
			SetVictoryBarFill(0.45)
		end
		if destroyed == 9 then
			SetVictoryBarFill(0.5)
		end
		if destroyed == 10 then
			SetVictoryBarFill(0.7)
			CastSpell("FireBall", 1, "fireball7",0)
	        CastSpell("FireBall", 1, "fireball8",0)
		    CastSpell("FireBall", 1, "fireball9",0)
			AddTimer(2,explosion2)
			AddTimer(5,circletarget2)
		end
		if destroyed == 12 then
			SetVictoryBarFill(0.8)
		end
		if destroyed == 13 then
		    ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN10C_6_5")
			SetTriggerCallbacks("circletrap", circletrap_onTriggerEnter)
			AddTargetCircle("circlearea")
			SetVictoryBarFill(1)
		end
	end
end

function circletrap_onTriggerEnter(unit)
	if unit.attacker then
        AddTimer(5,winner)
		PlayVFX("ElderStone_EnergyPropStones", "glow")
		DisableTrigger("circletrap")
	end
end

--winner function that sets the game to victorious
function winner()
    SetWinnable(true)
end

function QueueAssets()

   QueueVFX("PA_SpawnReinforcement")
   QueueVFX("Elderstone_EnergyPropStones")

end

function createStartingTroops(forPlinthInspector)
	
		SpawnUnits("start")
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start")
		SpawnUnits("start1")
		SpawnUnits("start2")
		SpawnUnits("start3")
		SpawnUnits("startambush")
		SpawnUnits("starttitan")
	end
end