safe = false
dead = 0
destroyed = 0
retreat = false
held = false

--SetUp

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SetMultipleUnitSelectionButtonEnabled(false)
    SetStandGuardButtonEnabled(false)
    SetAutoOrdersButtonEnabled(false)
    SetFightButtonEnabled(false)
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_INTRO")
	AddTimer(5.0, framecamera1)
	PlayVFX("ElderStone_EnergyProp", "elderstone") 
	PlayVFX("ElderStone_EnergyPropStones", "fx1") 
	PlayVFX("ElderStone_EnergyPropStones", "fx2") 
	PlayVFX("ElderStone_EnergyPropStones", "fx3") 
	PlayVFX("ElderStone_EnergyPropStones", "fx4") 
	PlayVFX("ElderStone_EnergyPropStones", "fx5") 
	SetWinnable(false)
	createStartingTroops(False)

end

function framecamera1(seconds)

	ShowDialog ("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_OBJECTIVE")
	FrameCamera("trigger1")
	AddTimer(4.0, ReturnCamera)
	AddTimer(4.5, ShowBattle)

end

function ShowBattle()
		SetMultipleUnitSelectionButtonEnabled(true)
        SetStandGuardButtonEnabled(true)
        SetAutoOrdersButtonEnabled(true)
        SetFightButtonEnabled(true)
end

function onLevelStart()
	DisableAiSpells()
	SetVictoryBarEnabled(false)
	SetWinnable(false)
	SetTriggerCallbacks("finalcamera", finalcamera_onTriggerEnter, finalcamera_onTriggerLeave)
	SetTriggerCallbacks("trigger2", trigger2_onTriggerEnter, trigger2_onTriggerLeave)
	SetTriggerCallbacks("trigger3", trigger3_onTriggerEnter, trigger3_onTriggerLeave)
	SetTriggerCallbacks("trigger4", trigger4_onTriggerEnter, trigger4_onTriggerLeave)
	
	local units = GetUnits("block1", "*", 1)
	for i,unit in pairs(units) do
	SetEnemyPlayers(2, 1)	
	end
	
	local units = GetUnits("civi", "*", 3)
	for i,unit in pairs(units) do
	SetAlliedPlayers(3, 0)	
	end
	
	AddTimer(9.0, Move1)
	AddTimer(1.0, VictoryCheck)

end

--end setup


--Civilian Movement Control
function StartCivi()
	if safe == false then
	PlayVFX("PA_SpawnReinforcement", "trigger1")
	AddTimer(1.0, SpawnCivi)
	end
	
end

function SpawnCivi()
	RespawnUnits("civi")
	local units = GetUnits("civi", "*", 3)
	for i,unit in pairs(units) do
	SetAlliedPlayers(3, 0)	
	end
	Move1()
end


function Move1()
	
	local units = GetUnits("civi", "*", 3)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "trigger2")
	end
	
end

-- End Civilian Movement Control

--Objective Tracking
--This checks to see how many units have escaped via trigger4.

function trigger4_onTriggerEnter(unit)
	if unit.spawnId == "civi" then
		safe = true
		VictoryCheck()
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_SAFE")
		local units = GetUnits("civi", "*", 3)
		for i,unit in pairs(units) do
		PlayVFX("PA_SpawnReinforcement", "trigger4")
		AddTimer(1.0, Despawn)
		end
	elseif unit.attacker and retreat == true then
	    AddTimer(4.5, finalframe)
		--win()
	end
end

function Despawn()	
		local units = GetUnits("civi", "*", 3)
		for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
		end
		safe = true
		dead = dead - 1
		
end

-- End section on Civilian Trigger check.

--Victory Conditions

function VictoryCheck()
	AddTimer(1.0, VictoryCheck)
	if safe == true and held == true then
		AddTimer(5.0, FinalBattle)
	end
	
end

function FinalBattle()
	if retreat == false and held == true and safe == true then
	retreat = true
	PlayVFX("PA_SpawnReinforcement", "finalcamera")
	AddTimer(1.0, framecamera2)
	end
	
end

function FinalSpawn()
	SpawnUnits("titan3")
	RespawnUnits("start1")
	RespawnUnits("start2")
	
	local units = GetUnits("*", "*", "0")
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, true)
	end
	
	local units = GetUnits("*", "*", "1")
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, true)
	end
		
end

function framecamera2(seconds)
	FrameCamera("finalcamera")
	AddTimer(1.0, FinalSpawn)
	ShowDialog ("Portraits/dip_alm_talkinghead","TXT_CAMPAIGN_11_10_TAUNT")
	AddTimer(3.0, ReturnCamera)
	AddTimer(4.0, Retreat)
end

function Retreat()
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_WIN")
	AddTargetCircle("trigger4")
	ShowGuideArrowForTrigger("trigger4")
	
	local units = GetUnits("*", "*", "0")
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, false)
	end
	
	local units = GetUnits("*", "*", "1")
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, false)
	end

end

function finalframe()
    AddTimer(1,win)
	FrameCamera("trigger4")
end

function win()
	Win()
end

function FailCheck()
	 if dead == 4 and safe == false then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_LOSE")
		Fail()
	elseif dead == 1 and safe == false then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_ONE")
	elseif dead == 3 and safe == false then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_THREE")
	end
end

function Fail()
	Lose()
end

--Victory Conditions


--Enemy Spawning vs objective units

function onUnitDestroyed(unit)
	if unit.spawnId == "civi" then
		dead = dead + 1
		AddTimer(4.0, StartCivi)
		FailCheck()
	elseif unit.defender then
		destroyed = destroyed + 1
		print(destroyed)
		if destroyed == 4 then
			PlayVFX("PA_SpawnReinforcement", "spawn1")
			PlayVFX("PA_SpawnReinforcement", "spawn2")
			AddTimer(1.0, wave1)
			RespawnUnits("start1")
			ShowDialog("Portraits/dip_ragnar_talkinghead","TXT_CAMPAIGN_11_10_RAGNAR")
		elseif destroyed == 8 then
			PlayVFX("PA_SpawnReinforcement", "spawn3")
			PlayVFX("PA_SpawnReinforcement", "spawn4")
			PlayVFX("PA_SpawnReinforcement", "spawn5")
			AddTimer(1.0, wave2)
			RespawnUnits("start2")
			ShowDialog("Portraits/dip_unak_talkinghead","TXT_CAMPAIGN_11_10_UNAK")
		elseif destroyed >= 13 then
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_10_HELD")
			held = true
		end
	end
end

--skeleton spawning

function trigger2_onTriggerEnter(unit)

	if unit.spawnId == "civi" then
	SpawnUnits("block2")
	
		local units = GetUnits("block2", "*", 1)
		for i,unit in pairs(units) do
		SetEnemyPlayers(1, 2)	
		SetUnitStandGround(unit, true)
		end
		
		local units = GetUnits("civi", "*", 3)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger3")
		SetAlliedPlayers(3, 0)	
	end
		
	end
end

function trigger3_onTriggerEnter(unit)

	if unit.spawnId == "civi" then
		SpawnUnits("block3")
		local units = GetUnits("block3", "*", 1)
		for i,unit in pairs(units) do
		SetEnemyPlayers(1, 2)	
		SetUnitStandGround(unit, true)
		end
			
		local units = GetUnits("civi", "*", 3)
		for i,unit in pairs(units) do
		GiveUnitMoveOrder(unit, "trigger4")
		SetAlliedPlayers(3, 0)	
		end
	end
end

function trigger3_onTriggerLeave(unit)

	if unit.spawnId == "civi" then
		SpawnUnits("block4")
	end
	local units = GetUnits("block4", "*", 1)
	for i,unit in pairs(units) do
	SetEnemyPlayers(1, 2)	
	SetUnitStandGround(unit, true)
	end

end

--end skeleton spawning


-- End Enemy Spawning vs objective units
function wave1()
	SpawnUnits("wave1")
	SpawnUnits("titan1")
end

function wave2()
	SpawnUnits("wave2")
	SpawnUnits("titan2")
end
	

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("block1")
	RespawnUnits("civi")
	RespawnUnits("start1")
	RespawnUnits("start2")
		
	if forPlinthInspector then
		SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("titan1")
		SpawnUnits("titan2")
		RespawnUnits("start2")
		RespawnUnits("start1")
		RespawnUnits("start2")
		RespawnUnits("start1")
		
	end
end