destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()

	SetWinnable(false)
	createStartingTroops(False)
	ShowDialog("Portraits/Soldier_talkinghead","TXT_CAMPAIGN_11_3_INTRO")
end

function onLevelStart()
	SetDisplayTimer(0,0)
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("stone1", stone1_onTriggerEnter, stone1_onTriggerLeave)
	SetTriggerCallbacks("stone2", stone2_onTriggerEnter, stone2_onTriggerLeave)
	SetTriggerCallbacks("stone3", stone3_onTriggerEnter, stone3_onTriggerLeave)
	SetTriggerCallbacks("circle", circle_onTriggerEnter, circle_onTriggerLeave)
	SetTriggerCallbacks("escape", escape_onTriggerEnter, escape_onTriggerLeave)
	SetTriggerCallbacks("ambush", ambush_onTriggerEnter, ambush_onTriggerLeave)
	SetTriggerCallbacks("fx8", fx8_onTriggerEnter, fx8_onTriggerLeave)
	SetTriggerCallbacks("fx9", fx9_onTriggerEnter, fx9_onTriggerLeave)
	SetTriggerCallbacks("fx10", fx10_onTriggerEnter, fx10_onTriggerLeave)
	SetTriggerCallbacks("reinforcements", reinforcements_onTriggerEnter, reinforcements_onTriggerLeave)
end

function escape_onTriggerEnter(unit)
	if unit.attacker then
		
		Win()
		DisableTrigger("escape")
	
	end
end

function stone1_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("ElderStone_EnergyPropStones", "fx4") 
		PlayVFX("ElderStone_EnergyPropStones", "fx7") 
		DisableTrigger("stone1")
	
	end
end

function stone2_onTriggerEnter(unit)
	if unit.attacker then

		PlayVFX("ElderStone_EnergyPropStones", "fx3") 
		PlayVFX("ElderStone_EnergyPropStones", "fx6") 
		DisableTrigger("stone2")
	
	end
end

function stone3_onTriggerEnter(unit)
	if unit.attacker then
		
		PlayVFX("ElderStone_EnergyPropStones", "fx2") 
		PlayVFX("ElderStone_EnergyPropStones", "fx5") 
		DisableTrigger("stone3")
	
	end
end

function ambush_onTriggerEnter(unit)
	if unit.attacker then
		ShowDialog("Portraits/Soldier_talkinghead","TXT_AKL_1")
		waves()
		DisableTrigger("ambush")
	
	end
end

function waves()
	SpawnUnits("wave")	
end

function reinforcements_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("ElderStone_EnergyProp", "fx1") 
		AddTimer(1.0, spawn_last)
		DisableTrigger("reinforcements")
		PlayVFX("PA_SpawnReinforcement", "fx8") 
		PlayVFX("PA_SpawnReinforcement", "fx9") 
		PlayVFX("PA_SpawnReinforcement", "fx10") 
	
	end
end

function spawn_last()	
	ShowDialog("Portraits/dip_alm_talkinghead","TXT_CAMPAIGN11_3_NOESCAPE")
	SpawnUnits("reinforce")
	SpawnUnits("wave2")
	AddTimer(3.0, KillFX)
end

function KillFX()
	StopVFX("ElderStone_EnergyProp", "fx1") 
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
	
		SpawnUnits("reinforce")
		SpawnUnits("wave")
		SpawnUnits("wave2")
		
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed >= 14 then
		 ShowDialog("Portraits/Soldier_talkinghead","TXT_CAMPAIGN11_3_VICTORY")
		 AddTargetCircle("circle")
		 ShowGuideArrowForTrigger("circle")
		 PlayVFX("ElderStone_EnergyProp", "fx1") 
		end
	end
end
