saved = false

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(False)
	PlayVFX("ElderStone_EnergyProp", "fx1")
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_4_INTRO")
	AddTimer(4.5, framecamera)
	SetMultipleUnitSelectionButtonEnabled(false)
    SetStandGuardButtonEnabled(false)
    SetAutoOrdersButtonEnabled(false)
    SetFightButtonEnabled(false)
end

function onLevelStart()           
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
    SetTriggerCallbacks("wave1", wave1_onTriggerEnter, wave1_onTriggerLeave)
	SetAI()
    AddTimer(140.0, Fail)
end

function framecamera(seconds)
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_4_SAVE")
	FrameCamera("focus")
	AddTimer(5.0, ReturnCamera)
	AddTimer(5.1, startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
    SetStandGuardButtonEnabled(true)
    SetAutoOrdersButtonEnabled(true)
    SetFightButtonEnabled(true)
end

function createStartingTroops(forPlinthInspector)
	SpawnUnits("attacker")
	SpawnUnits("defender")
	
	if forPlinthInspector then
		SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("defender")
	end
end

function SetAI()
	local units = GetUnits("defender", "*", 1)
	for i,unit in pairs(units) do
			SwitchSide(unit, 2)
			DisableAttackDamage(unit)
	end
	
	local units = GetUnits("attacker", "*", 3)
	for i,unit in pairs(units) do
			DisableAttackDamage(unit)
	end
end

function trigger1_onTriggerEnter(unit)
	if unit.attacker then
		saved = true
		SetWinnable(true)
		ShowDialog("Portraits/Soldier_talkinghead","TXT_CAMPAIGN_11_4_RESCUE")
		DisableTrigger("trigger1")
		local units = GetUnits("defender", "*", 2)
		for i,unit in pairs(units) do
				SwitchSide(unit, 1)
				EnableAttackDamage(unit)
		end

		local units = GetUnits("attacker", "*", 3)
		for i,unit in pairs(units) do
				SwitchSide(unit, 0)
				EnableAttackDamage(unit)
		end
	end
end

function wave1_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("wave1")
		PlayVFX("PA_SpawnReinforcement", "fx2")
		PlayVFX("PA_SpawnReinforcement", "fx3")
		PlayVFX("PA_SpawnReinforcement", "fx4")
		PlayVFX("PA_SpawnReinforcement", "fx5")
		PlayVFX("PA_SpawnReinforcement", "fx6")
		AddTimer(1.0, wave1_spawn)
		AddTimer(25.0, wave2_spawn)
		ShowDialog("Portraits/dip_alm_talkinghead","TXT_CAMPAIGNX_11_4_WAVE")
	end
end

function wave1_spawn()
	SpawnUnits("wave1")
end

function wave2_spawn()
	SpawnUnits("wave2")
end

function Fail()
	if saved == false then
		FrameCamera("focus")
		ShowDialog("Portraits/Soldier_talkinghead","TXT_CAMPAIGNX_11_4_LOSE")
		local units = GetUnits("attacker", "*", 3)
		for i,unit in pairs(units) do
			KillUnit(unit)
		end
		
		AddTimer(3.0, end_battle)	
	end
end

function end_battle()
	Lose()
end