retreat = false
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(false)
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_6_INTRO")
end

function onLevelStart()
	SetVictoryBarEnabled(false)
	SetTriggerCallbacks("trigger1", trigger1_onTriggerEnter, trigger1_onTriggerLeave)
	SetTriggerCallbacks("move1", move1_onTriggerEnter, move1_onTriggerLeave)
	SetTriggerCallbacks("move2", move2_onTriggerEnter, move2_onTriggerLeave)
	SetTriggerCallbacks("move3", move3_onTriggerEnter, move3_onTriggerLeave)
	SetTriggerCallbacks("move4", move4_onTriggerEnter, move4_onTriggerLeave)
	SetTriggerCallbacks("move5", move5_onTriggerEnter, move5_onTriggerLeave)
	SetTriggerCallbacks("move6", move6_onTriggerEnter, move6_onTriggerLeave)
	SetTriggerCallbacks("move6", move6_onTriggerEnter, move6_onTriggerLeave)
	SetTriggerCallbacks("escape", escape_onTriggerEnter, escape_onTriggerLeave)
	holdposition()
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("militia")
	SpawnUnits("pike1")
	SpawnUnits("pike2")
	SpawnUnits("unak5")
	SpawnUnits("unak6")
	SpawnUnits("archer3")
	SpawnUnits("archer4")
	
	if forPlinthInspector then
		SpawnUnits("militia")
		SpawnUnits("pike1")
		SpawnUnits("pike2")
		SpawnUnits("unak5")
		SpawnUnits("unak6")
		SpawnUnits("archer3")
		SpawnUnits("archer4")
		SpawnUnits("ambush")
	end
end

function epicfx()
	PlayVFX("PA_SpawnReinforcement", "fx1")
	PlayVFX("PA_SpawnReinforcement", "fx2")
	PlayVFX("PA_SpawnReinforcement", "fx3")
	PlayVFX("PA_SpawnReinforcement", "fx4")
	PlayVFX("PA_SpawnReinforcement", "fx5")
	PlayVFX("PA_SpawnReinforcement", "fx6")
	PlayVFX("PA_SpawnReinforcement", "fx7")
	PlayVFX("PA_SpawnReinforcement", "fx8")
	PlayVFX("PA_SpawnReinforcement", "fx9")
	PlayVFX("PA_SpawnReinforcement", "fx10")
	AddTimer(1.0, epicspawn)
end

function holdposition()
	local units = GetUnits("*", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, true)
	end
end

function trigger1_onTriggerEnter(unit)

	if unit.attacker then
		DisableTrigger("trigger1")
		moveunits()
		ShowDialog("Portraits/dip_alm_talkinghead","TXT_CAMPAIGN_11_6_MARCH")
		SpawnUnits("ambush")
	
	end

end

function move1_onTriggerEnter(unit)
		if unit.spawnId == "pike1" then
			local units = GetUnits("pike1", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end

function move2_onTriggerEnter(unit)
		if unit.spawnId == "pike2" then
			local units = GetUnits("pike2", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end

function move3_onTriggerEnter(unit)
		if unit.spawnId == "archer3" then
			local units = GetUnits("archer3", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end

function move4_onTriggerEnter(unit)
		if unit.spawnId == "archer4" then
			local units = GetUnits("archer4", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end


function move5_onTriggerEnter(unit)
		if unit.spawnId == "unak5" then
			local units = GetUnits("unak5", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end


function move6_onTriggerEnter(unit)
		if unit.spawnId == "unak6" then
			local units = GetUnits("unak6", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, true)
		end
	end
end

function escape_onTriggerEnter(unit)
	if unit.attacker and retreat == true then
		Win()
	end
end

function moveunits()
	local units = GetUnits("militia", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, false)
	end
	
	local units = GetUnits("archer3", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move3")
	end
	
	local units = GetUnits("archer4", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move4")
	end
	
	local units = GetUnits("pike1", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move1")
	end
	
	local units = GetUnits("pike2", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move2")
	end
	
	local units = GetUnits("unak5", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move5")
	end
	
	local units = GetUnits("unak6", "*", 1)
	for i,unit in pairs(units) do
	GiveUnitMoveOrder(unit, "move6")
	end
	
	local units = GetUnits("militia", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, false)
	end
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 6 then
			local units = GetUnits("*", "*", 1)
			for i,unit in pairs(units) do
			SetUnitStandGround(unit, false)
			end
		elseif destroyed == 9 then
			epicfx()
		end
		 
	end
end


function epicspawn()
	retreat = true
	ShowDialog("Portraits/dip_unak_talkinghead","TXT_CAMPAIGN_11_6_DESTROY")
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_11_6_RETREAT")
	SpawnUnits("finalspawn")
	nomove()
	AddTimer(20.0, movefinal)
	AddTargetCircle("circle")
	ShowGuideArrowForTrigger("circle")
	DisableAiSpells()
end

function nomove()
	local units = GetUnits("finalspawn", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, true)
	end
end

function movefinal()
	ShowDialog("Portraits/dip_unak_talkinghead","TXT_CAMPAIGN_11_6_ADVANCE")
	local units = GetUnits("finalspawn", "*", 1)
	for i,unit in pairs(units) do
	SetUnitStandGround(unit, false)
	end
end
