-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetTriggerCallbacks("enemy_attack", onTriggerEnter_trigger_enemy_attack, onTriggerLeave_trigger_enemy_attack)
	
	-- opening message
	ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_CAMPAIGN2A_4_1")
	
end

-- called after the deploy phase
function onLevelStart()
	
	
	-- get the initial list of units for us to track
	enemyUnits = GetUnits("*", "*", 1)
	friendlyUnits = GetUnits("*","*", 2)
	
	-- get all units to stand ground
	for i,unit in pairs(enemyUnits) do
		SetUnitStandGround(unit,true)
	end
	
	for i, unit in pairs(friendlyUnits) do
		SetUnitStandGround(unit,true)
	end 

	-- Set the archers as allied so you can't accidentally attack them (side 0 is player, side 2 is archers)
	SetAlliedPlayers(0, 2)
	
	-- clear any left over messages
	clearTutorialMessage()
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN2A_4_2")
	end
end
 
function clearTutorialMessage()
	-- clear any tutorial messages
	SetTutorial("")
	HideDialog()
end

function onTriggerEnter_trigger_enemy_attack(unit)

	-- if it's a friendly unit entering
	if unit.side == 0 then
	
		-- disable the trigger
		DisableTrigger("enemy_attack")
		
		-- get the enemy units to attack
		for i,unit in pairs(enemyUnits) do
			SetUnitStandGround(unit,false)
		end
		
		-- give control of the enemy archers
		AddTimer(3,gainControlOfFriendlyUnits)
	end
end

function gainControlOfFriendlyUnits()
	
	-- tell the player what's happening
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN2A_4_3")
	
	-- clear all of the guide arrows
	-- clear the guide arrows
	AddTimer(4.2,ClearArrows)
		
	-- clear all of the move to circles
	ClearTargetCircles()
	
	-- for every friendly unit
	for i,unit in pairs(friendlyUnits) do
		-- Change the units to player control
		SwitchSideToPlayer(unit)
		
		-- turn off the stand ground
		SetUnitStandGround(unit,false)
		
		-- point at the friendly units
		ShowUnitGuideArrow(unit)
	end
end

function ClearArrows()
    -- clear all of the guide arrows
    -- clear the guide arrows
	--ClearAllGuideArrows()
    ClearAllGuideArrows()
end

function onUnitSelected(selectedUnit)
	
	for i, unit in pairs(friendlyUnits) do
		if selectedUnit == unit then
			

				
			-- clear all of the move to circles
			ClearTargetCircles()
			
			break
		end
	end
	
end

