-- used to keep track of the number of assassinate units
assassinateUnits = {}

-- called at before the deploy phase
function onDeployStart()
	
	-- opening message
	ShowDialogDismiss("Portraits/Guard_talkinghead","TXT_CAMPAIGN2B_4_1")
	
	-- get the initial list of units for us to track
	assassinateUnits = GetUnits("*ASSASSINATE*")
	
end

-- called after the deploy phase
function onLevelStart()
	
	
	
	-- turn off the game timer
	SetDisplayTimer(0,0)
	SetVictoryBarType("ASSASSINATION")
	
	-- get the assassinate units ready
	for i,unit in pairs(assassinateUnits) do
		-- get all units to stand ground
		SetUnitStandGround(unit,true)
		
		-- set the assassination units as assassinate units
		AddAssassinationTarget(unit)
		
	end
	
	-- clear any left over messages
	clearTutorialMessage()
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN2B_4_2")
	end
end
 
function clearTutorialMessage()
	-- clear any tutorial messages
	SetTutorial("")
	HideDialog()
end

function onUnitDestroyed(deadUnit)
	-- if an enemy unit has died then remove it from the enemy unit array
	-- if the enemy forces drop below a set amount then trigger the clean up message
	if deadUnit.side == 1 then
		-- for each unit in the assassinateUnits array
		for i,unit in pairs(assassinateUnits) do
			-- if this is the dead unit then remove it from the array
			if unit == deadUnit then
				-- remove the element from the array at point i
				table.remove(assassinateUnits,i)
				
				-- if the enemy's army has dropped below 1 then win
				if #assassinateUnits < 1 then
					
					Win()
				end
				
				-- leave the for loop (because we've found the right unit)
				break
			end
		end
	end
end
