-- used to keep track of the number of enemy units
enemyUnits = {}
reinforcementsSpawned = false

-- called at before the deploy phase
function onDeployStart()
	
	
end

-- called after the deploy phase
function onLevelStart()
	
	-- get the enemy units
	enemyUnits = GetUnits("*", "*", 1)
	
	-- set all enemy units to stand ground
	for i, unit in pairs(enemyUnits) do
		--SetUnitStandGround(unit,true)
	end
	
	AddTimer(40,SpawnReinforcement_1)
	
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN3E_5_1")
	end
end

function SpawnReinforcement_1()
	
	SpawnUnits("Reinforcement_1")
	AddTimer(4,SpawnReinforcement_2)
	
end

function SpawnReinforcement_2()
	
	SpawnUnits("Reinforcement_2")
	AddTimer(4,SpawnReinforcement_3)
end

function SpawnReinforcement_3()
	
	SpawnUnits("Reinforcement_3")
end

function onUnitDestroyed(deadUnit)
	-- if an enemy unit has died then remove it from the enemy unit array
	-- if the enemy forces drop below a set amount then trigger the clean up message
	
	
	if not reinforcementsSpawned then
	
		if deadUnit.side == 1 then
		
			-- for each unit in the enemyUnits array
			for i,unit in pairs(enemyUnits) do
			
				-- if this is the dead unit then remove it from the array
				if unit == deadUnit then
				
					-- remove the element from the array at point i
					table.remove(enemyUnits,i)
					
					-- if the enemy army only has one unit left then spawn the reinforcements now
					if #enemyUnits <= 1 and not shownFinishThemOffDialogue then
						reinforcementsSpawned = true
						
						SpawnReinforcement_1()
					end
					
					-- leave the for loop (because we've found the right unit)
					break
				end
			end
		end
	end
end