
spawnLeft = true
if math.random(2) == 2 then
	spawnLeft = false
end

shownTeleportMessage = false

spawnCounter = 0

CreateRandomisedListOfThings("List_Teleport_Units_Right","Militia_Right","Archer_Right","Pikemen_Right")
CreateRandomisedListOfThings("List_Teleport_Units_Left","Militia_Left","Archer_Left","Pikemen_Left")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

-- called at before the deploy phase
function onDeployStart()
	-- register the effects
	PlayVFX("ElderStone_EnergyPropStones", "Portal_Effect_1")
	PlayVFX("ElderStone_EnergyPropStones", "Portal_Effect_2")
	PlayVFX("ElderStone_EnergyPropStones", "Portal_Effect_3")
	PlayVFX("ElderStone_EnergyPropStones", "Portal_Effect_4")
	
end

-- called after the deploy phase
function onLevelStart()
	
	-- turn off the game timer
	SetDisplayTimer(0,0)
	
	SetWinnable(false)

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN3E_6_1")
	end
end

function clearTutorialMessage()
	-- clear any tutorial messages
	SetTutorial("")
end

function onUnitDestroyed(deadUnit)


	enemyUnits = GetUnits("*", "*", 1)
	
	if spawnCounter < 6 then
		if #enemyUnits <= 2 then
	
			SpawnTeleportUnit()
			
			--AddTimer(2, SpawnTeleportUnit)
			
			spawnCounter = spawnCounter + 1	
			
			if not shownTeleportMessage then
				-- show dialog about finishing them off
				ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN3E_6_2")
				shownTeleportMessage = true
			end
		end
	else
		if #enemyUnits <= 0 then
			Win()
		end
	end
end

function SpawnTeleportUnit()
	
	-- determine which side we're going to spawn on and then switch the side for next time
	if spawnLeft == true then
		teleportStringEnd = "Left"
		spawnLeft = false
	else
		teleportStringEnd = "Right"
		spawnLeft = true
	end
	
	PlayVFX("PA_SpawnReinforcement", "Teleport_Effect_" .. teleportStringEnd)
	
	AddTimer(1,DelayedSpawnTeleportUnit,GetRandomisedRandomThing("List_Teleport_Units_" .. teleportStringEnd))
	
end

function DelayedSpawnTeleportUnit(unitID)
	
	print(unitID)
	
	RespawnUnits(unitID)
	
end

function createStartingTroops(forPlinthInspector)
	
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("Pikemen_Left")
		SpawnUnits("Militia_Left")
		SpawnUnits("Archer_Left")
		SpawnUnits("Pikemen_Right")
		SpawnUnits("Militia_Right")
		SpawnUnits("Archer_Right")


	end
	
end

