destroyed = 0
SpellLevel = 0
Rank = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	createStartingTroops(False)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
    AddTimer(5, startTitan0)	
	local units = GetUnits("*", "UnakHero*", 1)
	for i,unit in pairs(units) do
		IntroCamFrameUnit(unit)
		AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN6B_4_1")
end

function startTitan0()
	PlayVFX("PA_SpawnReinforcement", "titan")
	AddTimer(1, spawnTitan0)
end
function spawnTitan0()
	SpawnUnits("startTitan")
	ShowDialog("Portraits/dip_unak_talkinghead","TXT_CAMPAIGN6B_4_2")
	AddTimer(5, startMoss0)
end

function startMoss0()
	PlayVFX("PA_SpawnReinforcement", "moss0")
	AddTimer(1, spawnMoss0)
end
function spawnMoss0()
	SpawnUnits("startMoss0")
	AddTimer(0.2, startMoss1)
end

function startMoss1()
	PlayVFX("PA_SpawnReinforcement", "moss1")
	AddTimer(1, spawnMoss1)
end
function spawnMoss1()
	SpawnUnits("startMoss1")
	AddTimer(0.2, startMoss2)
end

function startMoss2()
	PlayVFX("PA_SpawnReinforcement", "moss2")
	AddTimer(1, spawnMoss2)
end
function spawnMoss2()
	SpawnUnits("startMoss2")
	AddTimer(0.2, startMoss3)
end

function startMoss3()
	PlayVFX("PA_SpawnReinforcement", "moss3")
	AddTimer(1, spawnMoss3)
end
function spawnMoss3()
	SpawnUnits("startMoss3")
	AddTimer(0.2, startMoss4)
end

function startMoss4()
	PlayVFX("PA_SpawnReinforcement", "moss4")
	AddTimer(1, spawnMoss4)
end
function spawnMoss4()
	SpawnUnits("startMoss4")
	ShowDialog("Portraits/dip_moss_talkinghead","TXT_CAMPAIGN6B_4_3")
	AddTimer(4.3, startgame)
end

function startgame()
	SetMultipleUnitSelectionButtonEnabled(true)
	SetStandGuardButtonEnabled(true)
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
end

function onLevelStart()
	SetTriggerCallbacks("rescue", rescue_onTriggerEnter, rescue_onTriggerLeave) 
	SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "UnakHero*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
	SetAI1() -- allies
	SetAI2() -- enemy attacking allies
	SetDisplayTimer(300,0)
end

function SetAI1() -- sets allies to not do damage
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
			--SetUnitStandGround(unit,true)
			DisableAttackDamage(unit)
	end
end

function SetAI2() -- sets attacker on allies to not do damage
	local units = GetUnits("*", "*", 3)
	for i,unit in pairs(units) do
			--SetUnitStandGround(unit,true)
			DisableAttackDamage(unit)
	end
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if unit.spawnId == "startTitan" then
		    SetVictoryBarType("NORMAL")
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN6B_4_4")
		local units = GetUnits("*", "*", 2) --switches sides and puts damage on
		for i,unit in pairs(units) do
			SwitchSide(unit, 0)
			EnableAttackDamage(unit)
		end
		local units = GetUnits("*", "*", 3)
		for i,unit in pairs(units) do
			SwitchSide(unit, 1)
			EnableAttackDamage(unit)
		end
	    end
		if destroyed == 5 then
		    SpawnUnits("start1")
		end
		if destroyed == 16 then
		    ShowDialogEternal("Portraits/dip_moss_talkinghead","TXT_CAMPAIGN6B_4_5")
			AddTimer(6,endgame)
		end
	end
end

function endgame()
    HideDialog()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
	
	SpawnUnits("start")
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start")
		SpawnUnits("start1")
		SpawnUnits("startTitan")
	end
end










