spawnCounter = 0
spawnTurn = 0
destroyed = 0
Leader = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	createStartingTroops(False)  -- This part here
	SpawnUnits("Leader", Leader)
	local units = GetUnits("*", "Leader*", 1)
		for i,unit in pairs(units) do
			IntroCamFrameUnit(unit)
			AddAssassinationTarget(unit) -- Set the enemy hero to be the assassination target.
	end
end


function onLevelStart()
    SetBattleTime(240,0)
	AddTimer(0.5,SpawnLoop)
	SetWinnable(false)
    SetVictoryBarType("ASSASSINATION")
	local units = GetUnits("*", "Leader*", 1)
	for i,unit in pairs(units) do
		AddAssassinationTarget(unit) -- We need to do this again, as the units from the deploy state are recreated in the battle state. Maybe assassination targets should be specified in the .json?
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN6D_3_1")
	end
end

-- spawns troops alternating between sides
function SpawnLoop()
 	spawnCounter = spawnCounter + 1
	if spawnTurn == 0 then
		AddTimer(9.0, playvfx1)	
		AddTimer(10.0, spawnme)
		spawnTurn = 1
	elseif spawnTurn == 1 then
		AddTimer(9.0, playvfx2)	
		AddTimer(10.0, spawnme2)
		spawnTurn = 2
	elseif spawnTurn == 2 then
		ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN6D_3_2")
		AddTimer(10.0, playvfx3)	
		AddTimer(11.0, spawnme3)
		spawnTurn = 3
	elseif spawnTurn == 3 then
		AddTimer(11.0, playvfx4)	
		AddTimer(12.0, spawnme4)
		spawnTurn = 0
		ShowDialog("Portraits/dip_unak_talkinghead", "TXT_CAMPAIGN6D_3_3")	
	end
	
	if spawnCounter <= 8 then
		AddTimer(20.0,SpawnLoop)
	end
end

function onUnitDestroyed(unit)
	if unit.spawnId == "Leader" then
		AddTimer(0.5,YouWin)
	end
end

function YouWin()
   Win()
 end
 
 function spawnme()
	RespawnUnits("wave1")
end

function spawnme2()
	RespawnUnits("wave2")
end

function spawnme3()
	RespawnUnits("wave3")
end

function spawnme4()
	RespawnUnits("wave4")
end

function playvfx1()
	PlayVFX("PA_SpawnReinforcement", "point1")
end
	
function playvfx2()
	PlayVFX("PA_SpawnReinforcement", "point2")
end

function playvfx3()
	PlayVFX("PA_SpawnReinforcement", "point3")
end

function playvfx4()
	PlayVFX("PA_SpawnReinforcement", "point4")
end

function createStartingTroops(forPlinthInspector)
	-- Balanced for castle level 7-8
	SpellLevel = 1
	Leader = 1
	
	
-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("wave3")
		SpawnUnits("wave4")
		SpawnUnits("Leader", Leader)
	end
end

