-- list of enemy units
enemyUnits = {}


-- called at before the deploy phase
function onDeployStart()
	
	-- register the triggers in the level
	SetTriggerCallbacks("Trigger_Reinforcement_Right", onTriggerEnter_Trigger_Reinforcement_Right, onTriggerLeave_Trigger_Reinforcement_Right)
	SetTriggerCallbacks("Trigger_Reinforcement_Left", onTriggerEnter_Trigger_Reinforcement_Left, onTriggerLeave_Trigger_Reinforcement_Left)
	
end

-- called after the deploy phase
function onLevelStart()
	
	-- get the enemy units
	enemyUnits = GetUnits("*", "*", 1)
	
	-- set all enemy units to stand ground
	for i, unit in pairs(enemyUnits) do
		--SetUnitStandGround(unit,true)
	end
	
	AddTimer(20,SpawnEverything)
	
end


function onTriggerEnter_Trigger_Reinforcement_Right(unit)

	if unit.side == 0 then
	
		DisableTrigger("Trigger_Reinforcement_Right")
		
		spawnFirstReinforcementRight()
		
	end
end

function onTriggerEnter_Trigger_Reinforcement_Left(unit)

	if unit.side == 0 then
		
		DisableTrigger("Trigger_Reinforcement_Left")
		
		spawnFirstReinforcementLeft()
	end
end

function spawnFirstReinforcementRight()
	SpawnUnits("Reinforcement_Right1")
	
	WarnPlayerAboutSpawns()
	
	AddTimer(4,spawnSecondReinforcementRight)
end

function spawnFirstReinforcementLeft()
	SpawnUnits("Reinforcement_Left1")
	
	WarnPlayerAboutSpawns()
	
	AddTimer(4,spawnSecondReinforcementLeft)
end

function spawnSecondReinforcementRight()
	SpawnUnits("Reinforcement_Right2")
end

function spawnSecondReinforcementLeft()
	SpawnUnits("Reinforcement_Left2")
end

function SpawnEverything()
	spawnFirstReinforcementRight()
	spawnFirstReinforcementLeft()
end



function WarnPlayerAboutSpawns()
	if not playerWarned then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN7C_1_1")
		
		playerWarned = true
	end
end