
escortDead = false
escortComplete = false

function onDeployStart()
	SetTriggerCallbacks("waypoint_1a", onTriggerEnter_Waypoint1A, onTriggerLeave_Waypoint1A)
	SetTriggerCallbacks("waypoint_1b", onTriggerEnter_Waypoint1B, onTriggerLeave_Waypoint1B)
	SetTriggerCallbacks("waypoint_1c", onTriggerEnter_Waypoint1C, onTriggerLeave_Waypoint1C)
	SetTriggerCallbacks("start_zone", onTriggerEnter_Start_Zone, onTriggerLeave_Start_Zone)
	
	
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_1")
end

function onLevelStart()
	SetAlliedPlayers(0,2)
	SetEnemyPlayers(1,2)
	SetWinnable(false)
	SetVictoryBarEnabled(false)
end

function onTriggerEnter_Start_Zone(unit)
	if unit.attacker then
		DisableTrigger("start_zone")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1a")
		ClearTargetCircles()
		AddTargetCircle("waypoint_1c")
		AddTimer(5,SpawnWaveOne)
	end
end

function onTriggerEnter_Waypoint1A(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1a")
		SetUnitStandGround(unit, true)
		AddTimer(10,waypoint1ADelay,unit)
	end
end

function waypoint1ADelay(unit)
	SetUnitStandGround(unit, false)
	GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1b")
	AddTimer(5,SpawnWaveTwo)
end

function onTriggerEnter_Waypoint1B(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1b")
		GiveNamedUnitMoveOrder("movingUnit_[start]", "waypoint_1c")
		AddTimer(5,SpawnWaveThree)
	end
end

function onTriggerEnter_Waypoint1C(unit)
	if unit.spawnId == "movingUnit_[start]" then
		DisableTrigger("waypoint_1c")
		SetUnitStandGround(unit, true)
		
		escortComplete = true
		ClearTargetCircles()
		
		enemyUnits =  GetUnits("*", "*", 1)
		if #enemyUnits > 0 then
			ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_7")
		else
			LevelComplete()
		end
		
	end
end

function onUnitDestroyed(unit)
	if unit.spawnId == "movingUnit_[start]" then
	
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_8")
		
		escortDead = true
		AddTimer(2,Lose)
	elseif unit.defender then
		if escortComplete then
			enemyUnits =  GetUnits("*", "*", 1)
			if #enemyUnits == 0 then
				LevelComplete()
			end
		end
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		HideDialog()
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_2")
		AddTargetCircleWithArrow("start_zone")
	end
end

function LevelComplete()
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_6")
	AddTimer(2, Win)
end

function SpawnWaveOne()
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_3")
	SpawnUnits("wave1")
end

function SpawnWaveTwo()
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_4")
	SpawnUnits("wave2")
end

function SpawnWaveThree()
	ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN8D_2_5")
	SpawnUnits("wave3")
end

function createStartingTroops(forPlinthInspector)
	
	
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("wave1")
		SpawnUnits("wave2")
		SpawnUnits("wave3")


	end
end
