-- used for which stage the level is at (which boss and enemies we spawn)
bossStage = 0

-- These are lists of unit ID's and the portal effects that then get returned to us in a random order
CreateRandomisedListOfThings("List_Spawn_Unit_IDs_WaveOne","1A","1B","1C","1D")

CreateRandomisedListOfThings("List_Spawn_Unit_IDs_WaveTwo","2A","2B","2C")

CreateRandomisedListOfThings("List_Spawn_Unit_IDs_WaveThree","3A","3B","3C","3D","3E","3F")

CreateRandomisedListOfThings("List_Portal_Effect_Locations","Portal_Stone_1","Portal_Stone_2","Portal_Stone_3","Portal_Stone_4","Portal_Stone_5")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()

	ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN9C_6_1")
	ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN9C_6_1")
	
end

function onLevelStart()

	SetWinnable(false)
	
	-- removed the victory bar until we have lua control over it
	SetVictoryBarEnabled(false)
	--SetVictoryBarType("WAVES")
	--AddVictoryBarMarker(0.4)
	--AddVictoryBarMarker(0.7)

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		HideDialog()
		ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN9C_6_2")
		bossStage = 1
		AddTimer(2,StartSpawningEffect)
		
	end
end


function onStartingEffectEnded()

	if bossStage == 1 then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN9C_6_3")
		AddTimer(2,FirstSpawn)
		
	elseif bossStage == 2 then
		SecondSpawn()
		
	elseif bossStage == 3 then
		ThirdSpawn()
		
	end
	
end

function FirstSpawn()
	
	AddTimer(1.4,HideDialog)
	AddTimer(1.5,ShowDialog,"Portraits/dip_alm_talkinghead","TXT_CAMPAIGN9C_6_4")
	
	SpawnUnitWithEffect("Boss",true)
	
	for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_WaveOne") do
		AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_WaveOne"), false)
	end
	
	AddTimer(1,StopVFX,"ElderStone_EnergyPropStones")
	
end

function SecondSpawn()

	
	AddTimer(1.4,HideDialog)
	AddTimer(1.5,ShowDialog,"Portraits/dip_alm_talkinghead","TXT_CAMPAIGN9C_6_5")
	
	SpawnUnitWithEffect("Boss",true)
	
	for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_WaveTwo") do
		AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_WaveTwo"), false)
	end
	
	AddTimer(1,StopVFX,"ElderStone_EnergyPropStones")
	
end

function ThirdSpawn()

	AddTimer(1.4,HideDialog)
	AddTimer(1.5,ShowDialog,"Portraits/dip_alm_talkinghead","TXT_CAMPAIGN9C_6_6")
	
	SpawnUnitWithEffect("Boss",true)
	
	for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_WaveThree") do
		AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_WaveThree"), false)
	end
	
	AddTimer(1,StopVFX,"ElderStone_EnergyPropStones")
	
end


function onUnitDestroyed(unit)
	
	local enemyUnitsRemaining = GetUnits("*","*",1)
	
	if #enemyUnitsRemaining == 0 then
		if bossStage == 1 then
			AddTimer(2, ShowDialog, "Portraits/Guard_talkinghead","TXT_CAMPAIGN9C_6_7")
			AddTimer(4,StartSpawningEffect)
			bossStage = 2
			
		elseif bossStage == 2 then
			AddTimer(2, ShowDialog, "Portraits/Guard_talkinghead","TXT_CAMPAIGN9C_6_8")
			AddTimer(4,StartSpawningEffect)
			bossStage = 3
			
		elseif bossStage == 3 then
			AddTimer(2, ShowDialog, "Portraits/Guard_talkinghead","TXT_CAMPAIGN9C_6_9")
			AddTimer(4,Win)
			
		end
	
	end
	
	if unit.spawnId == "unitSpawn_Boss" then
		AddTimer(4.5,HideDeadUnit,unit)
	end
end


function SpawnUnitWithEffect(unit_ID, respawnNotSpawn)
	PlayVFX("PA_SpawnReinforcement", "Spawn_Effect_" .. unit_ID)
	
	if respawnNotSpawn then
		AddTimer(1,RespawnUnits,"unitSpawn_" .. unit_ID)
	else
		AddTimer(1,SpawnUnits,"unitSpawn_" .. unit_ID)
	end
end

function StartSpawningEffect()
	
	local additionalTime = 0
	
	for i = 1, GetSizeOfRandomisedList("List_Portal_Effect_Locations") do
	
		additionalTime = i * (0.5 + (math.random()/4))
		AddTimer( 1 + additionalTime, PlayVFX, "ElderStone_EnergyPropStones",GetRandomisedRandomThing("List_Portal_Effect_Locations"))
	end
	
	AddTimer(1 + additionalTime, onStartingEffectEnded)
	
end

function createStartingTroops(forPlinthInspector)
	
	
	--SpawnUnits("startTitan")

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("unitSpawn_Boss")
		SpawnUnits("unitSpawn_1A")
		SpawnUnits("unitSpawn_1B")
		SpawnUnits("unitSpawn_1C")
		SpawnUnits("unitSpawn_1D")
		SpawnUnits("unitSpawn_2A")
		SpawnUnits("unitSpawn_2B")
		SpawnUnits("unitSpawn_2C")
		SpawnUnits("unitSpawn_3A")
		SpawnUnits("unitSpawn_3B")
		SpawnUnits("unitSpawn_3C")
		SpawnUnits("unitSpawn_3D")
		SpawnUnits("unitSpawn_3E")
		SpawnUnits("unitSpawn_3F")

	end
end