destroyed = 0
SpellLevel = 0
Rank = 0

-- used for which stage the level is at (which boss and enemies we spawn)
bossStage = 0

-- These are lists of unit ID's and the portal effects that then get returned to us in a random order
CreateRandomisedListOfThings("List_Spawn_Unit_IDs_WaveOne","1A","1B","1C","1D")

CreateRandomisedListOfThings("List_Spawn_Unit_IDs_WaveTwo","2A","2B","2C","2D")

CreateRandomisedListOfThings("List_Portal_Effect_Locations","Portal_Stone_2","Portal_Stone_3","Portal_Stone_4")

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
    createStartingTroops(False)
	ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN_RAGNAR_2_10_1")
	
end

function onLevelStart()

	SetWinnable(false)
	
	-- removed the victory bar until we have lua control over it
	SetVictoryBarEnabled(false)
	--SetVictoryBarType("WAVES")
	--AddVictoryBarMarker(0.4)
	--AddVictoryBarMarker(0.7)

end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		
		HideDialog()
		ShowDialog("Portraits/Guard_talkinghead", "TXT_CAMPAIGN_RAGNAR_2_10_2")
		bossStage = 1
		AddTimer(2,StartSpawningEffect)
		
	end
end


function onStartingEffectEnded()

	if bossStage == 1 then
		ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN_RAGNAR_2_10_3")
		AddTimer(2,FirstSpawn)
		
	elseif bossStage == 2 then
		SecondSpawn()
		
	end
	
end

function FirstSpawn()
	
	AddTimer(1.4,HideDialog)
	AddTimer(1.5,ShowDialog,"Portraits/Ragnar_talkinghead","TXT_CAMPAIGN_RAGNAR_2_10_4")
	
	SpawnUnitWithEffect("Boss",true)
	
	for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_WaveOne") do
		AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_WaveOne"), false)
	end
	
	AddTimer(1,StopVFX,"ElderStone_EnergyPropStones")
	
end

function SecondSpawn()

	
	AddTimer(1.4,HideDialog)
	AddTimer(1.5,ShowDialog,"Portraits/Ragnar_talkinghead","TXT_CAMPAIGN_RAGNAR_2_10_5")
	
	SpawnUnitWithEffect("Boss",true)
	
	for i = 1, GetSizeOfRandomisedList("List_Spawn_Unit_IDs_WaveTwo") do
		AddTimer( 1+(i/5), SpawnUnitWithEffect, GetRandomisedRandomThing("List_Spawn_Unit_IDs_WaveTwo"), false)
	end
	
	AddTimer(1,StopVFX,"ElderStone_EnergyPropStones")
	
end


function onUnitDestroyed(unit)
	
	local enemyUnitsRemaining = GetUnits("*","*",1)
	
	if #enemyUnitsRemaining == 0 then
		if bossStage == 1 then
			AddTimer(2, ShowDialog, "Portraits/Guard_talkinghead","TXT_CAMPAIGN_RAGNAR_2_10_6")
			AddTimer(4,StartSpawningEffect)
			bossStage = 2
			
		elseif bossStage == 2 then
			AddTimer(2, ShowDialog, "Portraits/Guard_talkinghead","TXT_CAMPAIGN_RAGNAR_2_10_7")
			AddTimer(4,Win)
			
		end
	
	end
	
	if unit.spawnId == "unitSpawn_Boss" then
		AddTimer(4.5,HideDeadUnit,unit)
	end
end


function SpawnUnitWithEffect(unit_ID, respawnNotSpawn)
	PlayVFX("PA_SpawnReinforcement", "Spawn_Effect_" .. unit_ID)
	
	if respawnNotSpawn then
		AddTimer(1,RespawnUnits,"unitSpawn_" .. unit_ID)
	else
		AddTimer(1,SpawnUnits,"unitSpawn_" .. unit_ID)
	end
end

function StartSpawningEffect()
	
	local additionalTime = 0
	
	for i = 1, GetSizeOfRandomisedList("List_Portal_Effect_Locations") do
	
		additionalTime = i * (0.5 + (math.random()/4))
		AddTimer( 1 + additionalTime, PlayVFX, "ElderStone_EnergyPropStones",GetRandomisedRandomThing("List_Portal_Effect_Locations"))
	end
	
	AddTimer(1 + additionalTime, onStartingEffectEnded)
	
end

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 6 and Rank <= 11 then
			SpellLevel = Rank -2
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
		elseif Rank >= 12 then
			SpellLevel = 12
			Army = 10
			Army1 = 11
			Army2 = 12
		end
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("unitSpawn_1A",Army)
		SpawnUnits("unitSpawn_1B",Army)
		SpawnUnits("unitSpawn_1C",Army)
		SpawnUnits("unitSpawn_1D",Army)
		SpawnUnits("unitSpawn_2A",Army)
		SpawnUnits("unitSpawn_2B",Army)
		SpawnUnits("unitSpawn_2C",Army)
		SpawnUnits("unitSpawn_2D",Army)
		SpawnUnits("unitSpawn_Boss",Army)
	end
end