
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0
playonce = 0
notindeployphase = false
spellonce = 0
onemessage = 0
cast = 0

-- no units alive at start of game so winnable set to false
function onDeployStart()
	--SetWinnable(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
end


-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	notindeployphase = true
	--SetDisplayTimer(300, 0)
--AddTimer(300.0, Lose)
	--SetVictoryBarEnabled(true)
	--SetupVictoryBar()
	AddTimer(2.0, DropSpell, "Fireball", 3, "drop3")	
	cast = 1
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowMessageBox("TXT_MISSION5_1","TXT_MISSION9_1")
		ShowDialogInPosition("Portraits/Guard_talkinghead","TXT_MISSION9_1","TOP_LEFT")
		DropSpell("Fireball", 3, "drop4")
		DropSpell("Fireball", 3, "drop1")
	end
end

function onTalkingHeadFinish(text)
	if text == "TXT_MISSION9_1" then
		SetFightButtonEnabled(true)
	end
end


function createStartingTroops(forPlinthInspector)
    
	-- Balanced for castle level 4
	
	
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("spawn1")
		SpawnUnits("spawn2")
	end
end



-- each time a spoil is picked up a new one will drop in the next place, alternates from place 1-4 and returns to 1
function onSpoilSpawned()
	-- Drop spells for n turns and then give no more
	if dropped == 0 then
		DropSpell("Fireball", 3, "drop1")
		--ShowGuideArrowForNextSpellDrop()
		dropped = dropped + 1
	elseif dropped == 1 then
		DropSpell("Fireball", 3, "drop3")
		dropped = dropped + 1
	elseif dropped == 2 then
		DropSpell("Fireball", 3, "drop2")
		dropped = dropped + 1
	elseif dropped == 3 then
		DropSpell("Fireball", 3, "drop4")
		dropped = dropped + 1
	elseif dropped == 4 then
		DropSpell("Fireball", 3, "drop1")
		dropped = dropped + 1
	elseif dropped == 5 then
		DropSpell("Fireball", 3, "drop3")
		dropped = dropped + 1
	elseif dropped == 6 then
		DropSpell("Fireball", 3, "drop2")
		dropped = dropped + 1
	elseif dropped == 7 then
		DropSpell("Fireball", 3, "drop4")
		dropped = dropped + 1	
	elseif dropped == 8 then
		DropSpell("Fireball", 3, "drop1")
		dropped = dropped + 1	
	elseif dropped == 9 then
		DropSpell("Fireball", 3, "drop3")
		dropped = dropped + 1
	elseif dropped == 10 then
		DropSpell("Fireball", 3, "drop2")
		dropped = dropped + 1
	elseif dropped == 11 then
		DropSpell("Fireball", 3, "drop4")
		dropped = dropped + 1
	end
end

	
-- Collecting a spoil shpould fire off a trigger to this function
function onSpellCollected(spellName, level)
	if spellonce == 0 and cast == 1 then
		playhandswipe()
		if onemessage == 0 then
			ShowDialog("Portraits/Guard_talkinghead","TXT_MISSION9_2")
			onemessage = 1
		end
	end
end

-- Using a spell will fire off a trigger to this function
function onSpellCast(spellName, level)
	-- when they use a spell, drop another one a little later than the last
	AddTimer((dropped * 1.1) + 1,onSpoilSpawned)
	if spellonce == 0 then
		CloseTutorialMovie()
		spellonce = 1
	end	
end


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 2 then
			CloseTutorialMovie()
			SpawnUnits("spawn1")
			SpawnUnits("spawn2")
		end
	end
end

function playhandswipe()
	PlayTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end


